//
//  ModuleMoleculeModel.swift
//  MVMCoreUI
//
//  Created by Suresh, Kamlesh on 11/26/19.
//  Copyright © 2019 Verizon Wireless. All rights reserved.
//

import Foundation

open class ModuleMoleculeModel: MoleculeModelProtocol {
    public var backgroundColor: Color?
    public static var identifier: String = "moduleMolecule"
    public var moduleName: String

    private enum CodingKeys: String, CodingKey {
        case moduleName
    }

    public init(_ moduleName: String) {
        self.moduleName = moduleName
    }

    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        moduleName = try typeContainer.decode(String.self, forKey:.moduleName)
    }

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moduleName, forKey: .moduleName)
    }
}
